%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Name:           libdasm
Version:        1.5
Release:        2%{?dist}
Summary:        Library for disassembling x86 code

Group:          System Environment/Libraries
License:        Public Domain
URL:            http://www.nologin.org/main.pl?action=codeView&codeId=49
Source0:        http://www.klake.org/~jt/misc/libdasm-1.5.tar.gz
Patch1:         libdasm-1.5-fix-Makefiles.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  python-devel
BuildRequires:  python-setuptools

%description
libdasm is a C-library that tries to provide simple and convenient way to
disassemble x86 raw opcode bytes (machine code). It can parse and print out
opcodes in AT&T and Intel syntax.

%package        devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

# We use the upstream name for the Python module:
%package        -n pydasm
Summary:        Python module for disassembling x86 machine code
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description    -n pydasm
pydasm is a python module for disassembling x86 machine code.  It is a
wrapper for libdasm.

# FIXME: I haven't yet wrapped rbdasm

%prep
%setup -q

# Fixup the Makefiles to remove upstream compilation flags:
%patch1 -p1

# Remove prebuilt Win32 DLLs from the tarball:
rm -rf bin

%build
PREFIX=`pwd` CFLAGS="$RPM_OPT_FLAGS" make %{?_smp_mflags}

# Build the Python module
pushd pydasm
CFLAGS="$RPM_OPT_FLAGS" %{__python} setup.py build
popd

# (FIXME: build the Ruby module)

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/include
mkdir -p $RPM_BUILD_ROOT/%{_libdir}

# Upstream "make include" hardcodes "lib", which isn't 64-bit friendly.
# It's sufficiently short that it's easiest to simply rewrite inline here:
cp libdasm.h  $RPM_BUILD_ROOT/usr/include/
cp libdasm.so $RPM_BUILD_ROOT/%{_libdir}
cp libdasm.so $RPM_BUILD_ROOT/%{_libdir}/libdasm.so.1.0

pushd pydasm
%{__python} setup.py install --skip-build --root $RPM_BUILD_ROOT
popd

# (FIXME: install the Ruby module)

%clean
rm -rf $RPM_BUILD_ROOT


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%defattr(-,root,root,-)
%doc HISTORY.txt LIB.txt README.txt TODO.txt
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root,-)
%{_includedir}/*
%{_libdir}/*.so

%files -n pydasm
%defattr(-,root,root,-)
%{python_sitearch}/*

%changelog
* Fri Jun  5 2009 David Malcolm <dmalcolm@redhat.com> - 1.5-2
- add python-devel to build requirements

* Fri May  8 2009 David Malcolm <dmalcolm@redhat.com> - 1.5-1
- initial packaging

